/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Miscellaneous routines                                                 *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <time.h>
#include <dos.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <mem.h>
#include <time.h>
#include <io.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <process.h>
#include <errno.h>

#ifdef OS_2
#define INCL_NOPM
#define INCL_VIO
#include <os2.h>
extern unsigned far pascal DosSleep(unsigned long time);
extern void SnWrite(char *str);
extern void Vidfcur(void);
#pragma check_stack(on)
#endif

#include "prog.h"
#include "alc.h"
#include "max.h"
#include "max_msg.h"
#include "dr.h"

static char *lastread_used;

static int num_ptr,
           byt,
           usize;

#ifndef ORACLE

int pascal Msg_Read_Lines(int msgfile,int msglines,int width,char **outline,char linetype[],char *last_line_attr)
{
  int temp,
      outl,
      column,
      wblen,
      y;

  unsigned char *msgbuffer,
                *msgbuf;

  char wordbuf[WORDBUFLEN+1],
       *msgend,
       *ts;

  if ((msgbuffer=malloc(BMSGBUFLEN))==NULL)
  {
    logit(mem_nrmb);
    return 0;
  }

  outl=wblen=0;
  msgeof=FALSE;

  mknl(wordbuf);

  /* Make sure that the specified width isn't greater than our maximum */

  if (width >= MAX_MSGWIDTH)
    width=MAX_MSGWIDTH;

  /* Initialize the line types to NORMAL, as opposed to QUOTE, SEEN-BY,    *
   * etc...                                                                */

  for (temp=0;temp < msglines;temp++)
  {
    mknl(outline[temp]);
    linetype[temp]=MSGLINE_normal;
  }

  /* Handle wrapped quote/seen-by lines properly. (Don't carry over        *
   * wrapped lines.)                                                       */

  linetype[0]=(*last_line_attr & ~MSGLINE_soft);

  /* Get the first batch of characters from the input file */

  temp=Read_Chars(msgfile,msgbuf=msgbuffer,MSGBUFLEN);
  msgend=min(msgbuf+MSGBUFLEN,msgbuf+temp);

  /* Skip over any possible 'AREA:' tag */
  if ((area.attrib[class] & ECHOMAIL) && strncmp(msgbuf,"AREA:",5)==0 &&
      !GEPriv(usr.priv,prm.ctla_priv))
  {
    while (((*msgbuf) != '\x0d') && ((*msgbuf) != (unsigned char)'\x8d'))
      msgbuf++;

    /* And finally skip over the last '\r' */

    msgbuf++;
  }

  if (! msgeof)
  {
    for (column=1,wblen=0;outl < msglines;msgbuf++)
    {
      /* If we're past the end of the buffer, read another line */

      if (msgbuf >= msgend && !msgeof)
      {
        temp=Read_Chars(msgfile,msgbuf=msgbuffer,MSGBUFLEN);
        msgend=min(msgbuf+MSGBUFLEN,msgbuf+temp);
      }

      if (! msgeof)
      {
        /* Trap for SEEN-BYs */

        if (column==1 && *msgbuf=='S')
        {
          if (msgbuf >= msgend-132 && temp==MSGBUFLEN)
          {
            /* Get rid of everything before the SEEN-BYs, which we don't     *
             * need. This ensures that we have enough space to read all of   *
             * the SEEN-BY into memory.                                      */

            memmove(msgbuffer,msgbuf,(msgend-msgbuf));

            /* Reset the pointers */
            msgend -= (msgbuf-msgbuffer);
            msgbuf=msgbuffer;

            temp=Read_Chars(msgfile,msgend,
                            min(MSGBUFLEN,(msgbuffer+BMSGBUFLEN)-msgend));

            msgend=min(msgend+MSGBUFLEN,msgend+temp);
          }

          ts=msgbuf;

          if (*++ts=='E' && *++ts=='E' &&* ++ts=='N' &&
              *++ts=='-' && *++ts=='B' && *++ts=='Y' &&
              *++ts==':' && *++ts==' ')
            linetype[outl] |= MSGLINE_seenby;
        }

        if (((*msgbuf >= ' ') && (*msgbuf != (unsigned char)'\x8d')) || (*msgbuf=='\t'))
        {
          /* If this is a quote, then say so */

          if (*msgbuf=='>' && column <= 4)
            linetype[outl] |= MSGLINE_quote;

          /* Copy the character into the buffer */

          wordbuf[wblen++]=*msgbuf;


          /* Word-wrap time... */

          if (column > width)
          {
            /* Soft wordwrap */
            linetype[outl] |= MSGLINE_soft;

            /* If the current line is either a seen-by, kludge, or quote... */

            if (linetype[outl] & (MSGLINE_seenby | MSGLINE_kludge | MSGLINE_quote))
            {
              /* Since it is one of the above, we should copy the quote or   *
               * seen-by attribute to the following line, so that our        *
               * display doesn't get mucked up.  If the current line is the  *
               * last line in the message, then plug the attribute into      *
               * *last_line_attr, so we can get it on our next pass.         */

              if (outl+1==msglines)
                *last_line_attr=linetype[outl] & ~MSGLINE_soft;
              else linetype[outl+1]=linetype[outl] & ~MSGLINE_soft;
            }

            wordbuf[wblen]='\0';

            if (*outline[outl]=='\0' && strlen(wordbuf) >= width-1)
            {
              wblen=0;
              mknl(wordbuf);
            }

            outl++;

            /* Find out how to wrap the word... */

            for (y=0;y < wblen;y++)
            {
              if (wordbuf[y] != ' ')
              {
                /* Got it!  Now move it back... */

                movmem(&wordbuf[y],wordbuf,wblen-y);

                wblen -= y;
                break;
              }
            }

            column=wblen+1;
          }
          else if (isspace(*msgbuf) || wblen >= WORDBUFLEN)
          {
            /* It was a space, so null out the word buffer, and add the      *
             * word to the line.                                             */

            wordbuf[wblen]='\0';
            strcat(outline[outl],wordbuf);
            wblen=0;
          }

          column++;
        }
        else    /* Else it isn't a printing ASCII character */
        {
          if (*msgbuf=='\r' || *msgbuf=='\0')
          {
            wordbuf[wblen]='\0';

            strcat(outline[outl++],wordbuf);

            column=1;
            wblen=0;

            if (*msgbuf=='\0' && msgbuf < msgend-1)
              break;
          }
          else if (*msgbuf=='\x01' && column==1)
            linetype[outl] |= MSGLINE_kludge;
          /* else ignore it */
        }
      }
      else
      {
        wordbuf[wblen]='\0';

        strcat(outline[outl++],wordbuf);

        column=1;
        wblen=0;

        break;
      }
    }
  }

  /* Seek back in case we didn't make it all the way to msgend or wblen */
  lseek(msgfile,(long)(msgbuf-msgend)-wblen,SEEK_CUR);

  /* If we're at the end of the message, then set appropriate flags */

  for (temp=outl;temp < msglines;temp++)
    linetype[temp]=MSGLINE_end;

  free(msgbuffer);

  /* Return number of lines we got */
  return outl;
}

#endif /* !ORACLE */


/* Add a line to the system log...  First character in string is the
   character to add at the beginning of the line -- The rest is the line
   to log.  Can include printf()-style formatting info.                   */

void cdecl logit(char *format,...)
{
#ifndef ORACLE

  time_t gmtime;
  struct tm *localt;

  char string[120],
       string2[200],
       screen_log,
       *p;

  va_list var_args;

  int doit;


  va_start(var_args,format);
  vsprintf(string,format,var_args);
  va_end(var_args);

  p=string;

  if (*p=='>')
  {
    screen_log=TRUE;
    p++;
  }
  else screen_log=FALSE;

  gmtime=time(NULL);
  localt=localtime(&gmtime);

  doit=FALSE;

  switch(*p)
  {
    case '!':
    case '*':
    case '+':
    case '=':
      doit=TRUE;
      break;

    case '#':
      if (prm.log_mode >= LOG_verbose)
        doit=TRUE;
      break;

    case ':':
    case '~':
      if (prm.log_mode >= LOG_trace)
        doit=TRUE;
      break;

    case ' ':     /* Never log these lines */
      doit=FALSE;
      break;

    default:
      doit=TRUE;
      break;
  }

  sprintf(string2, logformat, p[0], localt->tm_mday,
            months_ab[localt->tm_mon], localt->tm_hour,
            localt->tm_min, localt->tm_sec, nameabbr, p+1);

  #if defined(DESQSNOOP)
    DesqSnoopMsg(string2);
  #elif defined(OS_2)
    SnWrite(string2);
  #endif

  if (doit)
  {
    LogWrite(string2);

    if (*string=='!')   /* Something fishy, make sure it stays on record! */
      LogFlush();
  }

  /* Flush each line regardless, if we're running a test version, since  *
   * we may need this output if it crashes beforehand.                   */

  #if defined(FLUSH_LOG) && !defined(OS_2)
  LogFlush();
  #endif


  if ((!snoop && !local) || !caller_online || in_file_xfer || screen_log)
  {
    Lputs(GRAY "\r");
    Lputs(string2);
  }

  vbuf_flush();
#endif
}




/*
 * Pauses for <duration> hudredths of seconds, while
 * giving away timeslice.
 */

void pascal Delay(unsigned int duration)
{
#ifdef OS_2

  vbuf_flush();
  DosSleep((unsigned long) duration*10L);

#else

  long tim;

  vbuf_flush();

  tim=timerset(duration);

  while (! timeup(tim))
    Giveaway_Slice();

#endif
}


void pascal Giveaway_Slice(void)
{
  static long cd_loss=-1L,
              last=-1L;
            
  static int pvar=-1;

#ifndef ORACLE

  Draw_StatusLine(STATUS_normal);

  if (pvar==-1)
  {
    if (port != -1)
      pvar=port;
  }
  else if (port != pvar)
  {
    logit(s(log_pvchg));
    LogClose();
    _exit(ERROR_critical);
  }

  if (!local && !carrier())
  {
    if (cd_loss==-1L)
      cd_loss=time(NULL);
    else if (time(NULL) >= cd_loss+20)  /* Give sufficient time to log off normally */
    {
      if (time(NULL) != last)
      {
        last=time(NULL);

        Lprintf(s(robo_warn),
                (cd_loss+30)-time(NULL));
      }

      if (time(NULL) > cd_loss+30)
      {
        logit(s(log_robo_bye));
        LogClose();
        _exit(ERROR_critical);
      }
    }
  }

  LogFlush();

#endif /* !ORACLE */

#ifdef OS_2
  DosSleep(1L);
#else

  switch(multitasker)
  {
    case MULTITASKER_doubledos:
      ddos_sleep();
      break;

    case MULTITASKER_topview:
    case MULTITASKER_desqview:
       desq_sleep();
       break;

    case MULTITASKER_pcmos:
      pcmos_sleep();
      break;
  }
#endif
}



#ifndef ORACLE

#ifdef OS_2
void pascal Draw_StatusLine(int clearit)
{
  /* These are declared static, so they won't use any stack space. */
  static char bufr[80];
  static long secs_left, last=0;
  BYTE attr;


  if (displaymode==VIDEO_ibm && (prm.flags & FLAG_statusline))
  {
    if(clearit==STATUS_normal)
    {
      /* Time limit should stay stable while in CHAT mode */
      if (!inchat)
        secs_left=((signed long)timeoff-(signed long)time(NULL));
      if(last != secs_left || clearit==STATUS_force)
      {
        last = secs_left;
        sprintf(bufr,"%-18.18s %-16.16s %-14.14s %9.9s%s%-8.8s %4ld:%02ld  ",
                usr.name,usr.realname,usr.phone,Priv_Level(usr.priv),
                *Keys(usr.key) ? "/" : " ",Keys(usr.key),
                secs_left/60L,secs_left % 60L);

        attr = 112;
        VioWrtCharStrAtt(bufr, strlen(bufr), VidNumRows(), 0, &attr, 0);
        if (chatreq)
        {
          attr |= 128;
          VioWrtCharStrAtt("C", 1, VidNumRows(), VidNumCols()-2, &attr, 0);
        }
      }
      else
        DosSleep(1L);
    }
    else
    {
        VioWrtNCell(" \x7", VidNumCols(), VidNumRows(), 0, 0);
    }
  }
}

#else

#define STATUS_nattr  ((char)112)
#define STATUS_clattr ((char)7)

void pascal Draw_StatusLine(int clearit)
{
  /* These are declared static, so they won't use any stack space. */

  static char *bufr,
              save_attr;

  static long secs_left,
              last=0L;

  static int save_row,
             save_col;

  /* Only do this if mode==VIDEO_ibm and if statusline is enabled */

  if (! (displaymode==VIDEO_ibm && (prm.flags & FLAG_statusline)))
    return;

  if (clearit==STATUS_remove)
  {
    save_col=VidWhereX();
    save_row=VidWhereY();
    save_attr=VidGetAttr();

    VidGotoXY(1,VidNumRows()+1,FALSE);
    VidSetAttr(STATUS_clattr);

    VidCleol();

    VidSetAttr(save_attr);
    VidGotoXY(save_col,save_row,FALSE);
    return;
  }

  secs_left=((signed long)timeoff-(signed long)time(NULL));

  if (secs_left < 0L)
    secs_left=0L;

  /* Time limit should stay stable while in CHAT mode, and line          *
   * should only be updated once per second.                             */

  if ((clearit != STATUS_force && (inchat || secs_left==last)) ||
      (bufr=malloc(81))==NULL)
    return;

  last=secs_left;

  save_col=VidWhereX();
  save_row=VidWhereY();
  save_attr=VidGetAttr();

  VidGotoXY(1,VidNumRows()+1,FALSE);
  VidSetAttr(STATUS_nattr);

  sprintf(bufr,"%-16.16s %-16.16s %-14.14s %9.9s%s%-8.8s %4ld:%02ld",
          usr.name,usr.realname,usr.phone,Priv_Level(usr.priv),
          usr.key ? "/" : " ",Keys(usr.key),
          secs_left/60L,secs_left % 60L);

  VidPuts(bufr);
  free(bufr);

  if (chatreq)
  {
    VidSetAttr(STATUS_nattr | 128);
    VidPuts(" C");
  }

  VidCleol();

  VidSetAttr(save_attr);
  VidGotoXY(save_col,save_row,FALSE);
}

#endif /* !OS_2 */


/* Strip out any ESC characters from the string s.  Used mainly to strip
   ANSI crap from the To/From/Subj fields, but it is used for a few other
   miscellaneous items.                                                   */

char * pascal Strip_Ansi(char *s,int area,int msgnum)
{
  char *orig_s;

  orig_s=s;

  while (*s)
  {
    if (*s=='\x1b')
    {
      if (area != 0 && msgnum != 0)
        logit(s(log_got_ansi),Area_Name(area),msgnum);

      *s='<';
    }

    s++;
  }

  return orig_s;
}




/* Turn on/off remote ^C/^K checking and XON (^s/^q) flow control */

void pascal Mdm_Flow(int state)
{
  if (local)
    return;

  if (state==FLOW_on)
  {
    (void)mdm_ctrlc(1);
    mdm_flow(prm.handshake_mask);
  }
  else if (state==FLOW_partial_off)
  {
    /* Turn off control-C/K checking, and use all flow control except      *
     * for XON/XOFF!                                                       */

    (void)mdm_ctrlc(0);
    mdm_flow(prm.handshake_mask & ~FLOW_txoff);
  }
  else if (state==FLOW_off)
  {
    (void)mdm_ctrlc(0);
    mdm_flow(0);
  }
}

#endif /* !ORACLE */


/* Convert the "Format Date" and "Format Time" strings into something      *
 * that we can pass to strftime()...                                       */

char * pascal Timestamp_Format(char *format,struct _stamp *sstamp,char *out)
{
  struct tm localt;

  char sfmt[255],
       *p;

  strcpy(p=sfmt,format);

  while (*p)
  {
    if (*p=='%')
    {
      switch(*++p)
      {
        case '\0':      /* Guard against pilot booboo */
          *p='\0';
          break;

        case 'A':
          *p='p';
          break;

        case 'B':
          *p='m';
          break;

        case 'C':
          *p='b';
          break;

        case 'D':
          *p='d';
          break;

        case 'E':
          *p='I';
          break;

        case 'H':
          *p='H';
          break;

        case 'M':
          *p='M';
          break;

        case 'S':
          *p='S';
          break;

        case 'Y':
          *p='y';
          break;

        default:
        case '%':
          *p='%';
          break;
      }
    }

    p++;
  }

  OpusDate_to_TmDate(&localt,sstamp);

  strftime(out,BUFLEN,sfmt,&localt);

  return out;
}


/* Convert an Opus-style (ie. DOS) bit-mapped date into a 'struct tm'-type *
 * date.                                                                   */

struct tm * pascal OpusDate_to_TmDate(struct tm *tmdate,struct _stamp *opusdate)
{
  tmdate->tm_mday=opusdate->date.da;
  tmdate->tm_mon =opusdate->date.mo-1;
  tmdate->tm_year=opusdate->date.yr+80;

  tmdate->tm_hour=opusdate->time.hh;
  tmdate->tm_min=opusdate->time.mm;
  tmdate->tm_sec=opusdate->time.ss*2;

  return tmdate;
}

/* Convert a 'struct tm'-type date into an Opus/DOS bitmapped date */

struct _stamp * pascal TmDate_to_OpusDate(struct tm *tmdate,struct _stamp *opusdate)
{
  opusdate->date.da=tmdate->tm_mday;
  opusdate->date.mo=tmdate->tm_mon+1;
  opusdate->date.yr=tmdate->tm_year-80;

  opusdate->time.hh=tmdate->tm_hour;
  opusdate->time.mm=tmdate->tm_min;
  opusdate->time.ss=tmdate->tm_sec/2;

  return opusdate;
}


char * pascal Strip_Underscore(char *s)
{
  char *orig;

  orig=s;

  while (*s)
  {
    if (*s=='_')
      *s++=' ';
    else s++;
  }

  return orig;
}



void pascal Blank_User(struct _usr *user)
{
  memset(user,'\0',sizeof(struct _usr));

  user->help=NOVICE;
  user->use_lore=user->more=user->ibmchars=user->formfeed=1;
  user->priv=prm.logon_priv;
  user->width=80;
  user->len=24;
  user->msg=prm.begin_msgarea;
  user->files=prm.begin_filearea;
  user->struct_len=sizeof(struct _usr)/20;
}


int pascal Read_Chars(int fd,char *s,int num)
{
  int n;

  if ((n=read(fd,s,num))==0)
    msgeof=TRUE;

  return n;
}



/* Skip until the next \r (plus possibly \n) in a stdio-type file */

void pascal Skip_Line(FILE *bbsfile)
{
  int ch;

  while (1)
  {
    while ((ch=getc(bbsfile)) != '\r' && ch != EOF)
      ;

    if (ch==EOF)
      break;

    if ((ch=getc(bbsfile))=='\n')
      break;
    else ungetc(ch,bbsfile);
  }
}


/* Find the user's priv, and set class number appropriately */

void pascal Find_Class_Number(void)
{
  int x;

  for (x=0;x < MAXCLASS;x++)
  {
    if (usr.priv==prm.class[x].priv)
    {
      class=x;

      if (!local && (baud < prm.class[class].min_baud))
      {
        logit(ltooslow,baud,prm.class[class].min_baud);

        Display_File(0,NULL,PRM(tooslow));
        mdm_hangup();
      }

      break;
    }
  }

  if (x==MAXCLASS && !(prm.logon_priv==PREREGISTERED && usernum==-1))   
  {
    /* We couldn't find a record for this priv level in the */
    /* control file, his/her user record must be garbled!   */

    logit(s(no_class_rec),usr.name);
    mdm_hangup();
  }
}


/* Make sure that SYSTEM*.BBS-type structures are in the right format */

void pascal Fix_Area(struct _area *area)
{
  Add_Slash(area->msgpath);
  Add_Slash(area->uppath);
  Add_Slash(area->filepath);
}



/* Append a backslash to a string, if one does not already exist. */
void pascal Add_Slash(char *s)
{
  int x;

  if (s[x=strlen(s)] != '\\')
  {
    s[++x]='\\';
    s[++x]='\0';
  }
}


void pascal You_Cant_Get_There(void)
{
  Puts(s(cant_get_there));
  Press_ENTER();
}


/* Determines whether or not a string has any real text */

int pascal isblstr(char *s)
{
  if (s)
  {
    while (*s)
      if (isalnum(*s++))
        return FALSE;
  }

  return TRUE;
}



/* Add 'seconds' more seconds to our user's time limit, as long as we      *
 * don't overrun the command-line '-t' parameter, if any.                  */

long pascal Add_To_Time(long seconds)
{
  long temp1,
       temp2,
       temp3;

  /* Save the original value */
  temp3=timeoff;

  temp1=timeon+(unsigned long)(max_time*60L);
  temp2=timeoff+seconds;


/*
  logit("@debug temp1=%ld temp2=%ld temp3=%ld seconds=%ld",temp1,temp2,temp3,seconds);
  logit("@debug max_time=%ld timeoff=%ld timeon=%ld mt*60L=%ld, +=%ld",max_time,timeoff,timeon,max_time*60L,timeon+max_time*60L);
*/

  timeoff=min(temp1,temp2);

  /* And return how many seconds were actually added... */

  return timeoff-temp3;
}



#ifndef ORACLE

/* Allocate a block of memory for another line in MaxEd/BORED */

int pascal Allocate_Line(int linenum)
{
  /* Make sure we have enough room to jump back and abort peacefully! */
  if (coreleft() <= 500u)
    return -1;

  if ((screen[linenum]=(char *)malloc(MAX_LINELEN+2))==NULL)
    return -1;

  screen[linenum][0]=HARD_CR;
  screen[linenum][1]='\0';

  num_lines++;

  return 0;
}


/* Free the memory for a line in MaxEd/BORED */

void pascal Free_Line(int linenum)
{
  if (screen[linenum])
    free(screen[linenum]);

  screen[linenum]=NULL;
  num_lines--;
}


/* Free all of the currently-allocated lines in MaxEd/BORED */

void pascal Free_All(void)
{
  int x;

  for (x=num_lines;x >= 1;x--)
    Free_Line(x);

  if (screen[max_lines] && max_lines > 0)
  {
    Free_Line(max_lines);
    screen[max_lines]=NULL;
  }
}


#endif /* !ORACLE */


char * pascal Help_Level(int help)
{
  switch (help)
  {
    case HOTFLASH:
      return (s(hotfl));

    case EXPERT:
      return (s(exper));

    case REGULAR:
      return (s(regul));

    default:
      return (s(novic));
  }
}


/* Returns an ASCIIZ string containing the numbers of the keys that the    *
 * current user has.                                                       */

char * pascal Keys(int key)
{
  static char keys[9];
  char *s;
  int x;

  s=keys;

  for (x=0;x < 8;x++)
    if (key & (1 << x))
      *s++=(char)('1'+x);

  *s='\0';

  return keys;
}


/* FinishUp() *must* be declared cdecl because it is called by atexit()... *
 * It just makes a normal call to the *real* FinishUp() function, which is *
 * kept in another overlay to save space.  Since we can't do indirect      *
 * (ie. via pointers) function calls between overlays, we have to do it    *
 * this way...                                                             */

void cdecl FinishUp(void)
{
  #ifdef ORACLE /* If in ORACLE, do the simple finishup procedure */

      if (displaymode==VIDEO_ibm)
        VidClose(multitasker==MULTITASKER_desqview);

  #else /* Else do the complicated one... */

      FinishUp2(TRUE);

  #endif
}



/* This makes sure a file gets flushed to disk.  Thanks to Ray Duncan      *
 * for this tip in his _Advanced MS-DOS_ book.                             */

void pascal flush_handle(FILE *fp)
{

  fflush(fp);

#if defined(OS_2)
  DosBufReset(fileno(fp));
#else
#if defined(MSDOS) || defined(__TURBOC__)
  flush_handle2(fileno(fp));
#else
  {
    int nfd;

    if ((nfd=dup(fileno(fp))) != -1)
      close(nfd);
  }
#endif
#endif
}


/* Determine if a user can see a particular message */
int pascal CanSeeMsg(struct _msg *msg)
{
  if (! (msg->attr & MSGPRIVATE) ||
      eqstri(Strip_Trailing_Blanks(msg->to),usr.name) ||
      eqstri(Strip_Trailing_Blanks(msg->from),usr.name) ||
      GEPriv(usr.priv,prm.pvt_priv))
    return TRUE;
  else return FALSE;
}


int pascal GEdate(union stamp_combo *s1,union stamp_combo *s2)
{
  /* Compare the date of `s1' and `s2'.  Definitely the long way around    *
   * the barn, but portable.                                               */

  if (s1->msg_st.date.yr >= s2->msg_st.date.yr)
  {
    if (s1->msg_st.date.yr > s2->msg_st.date.yr)
      return TRUE;
    else if (s1->msg_st.date.mo >= s2->msg_st.date.mo)
    {
      if (s1->msg_st.date.mo > s2->msg_st.date.mo)
        return TRUE;
      else if (s1->msg_st.date.da >= s2->msg_st.date.da)
      {
        if (s1->msg_st.date.da > s2->msg_st.date.da)
          return TRUE;
        else if (s1->msg_st.time.hh >= s2->msg_st.time.hh)
        {
          if (s1->msg_st.time.hh > s2->msg_st.time.hh)
            return TRUE;
          else if (s1->msg_st.time.mm >= s2->msg_st.time.mm)
          {
            if (s1->msg_st.time.mm > s2->msg_st.time.mm)
              return TRUE;
            else if (s1->msg_st.time.ss >= s2->msg_st.time.ss)
              return TRUE;
          }
        }
      }
    }
  }

  return FALSE;
}




#ifdef __TURBOC__     /* MSC and others already have this function */

/* always uses modification time */
int cdecl utime(char *name, struct utimbuf *times)
{
  int handle;
  struct date d;
  struct time t;
  struct ftime ft;

  unixtodos(times->modtime, &d, &t);
  ft.ft_tsec = t.ti_sec / 2;
  ft.ft_min = t.ti_min;
  ft.ft_hour = t.ti_hour;
  ft.ft_day = d.da_day;
  ft.ft_month = d.da_mon;
  ft.ft_year = d.da_year - 1980;

  if ((handle=shopen(name,O_RDWR)) == -1)
    return -1;

  setftime(handle, &ft);
  close(handle);
  return 0;
}

#endif


#ifndef ORACLE

/* This function parses the "Format MsgHeader xxx"-type junk into          *
 * something that is displayable.                                          */

int pascal Parse_Custom_Area_Listing(struct _area *carea,char *parm,char *outparm,int first)
{
  static int cnt;
  struct _area *sarea;
  
  char temp[PATHLEN],
       *in,
       *out,
       *p,
       *s;

  int x,
      lalign,
      lrfile,
      lrptr,
      to_skip,
      max,
      min;
    
  if (first)
    cnt=0;

  for (in=parm,out=outparm,to_skip=0;*in;in++)
  {
    if (*in=='%')
    {
      max=min=-1;
      lalign=TRUE;

Again:

      switch (*++in)
      {
        case '-':
          lalign=TRUE;

          if (isdigit(*(in+1)))
          {
            in++;
            goto Next;
          }
          else goto Again;

        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case '0':

          lalign=FALSE;
Next:
          min=atoi(in);

          while (isdigit(*in++))
            ;

          in--;

          if (*in=='.')
          {
            max=atoi(++in);

            while (isdigit(*in++))
              ;

            in--;
          }

          in--;
          goto Again;

        case 'x':
          sscanf(++in,"%2x",&x);
          *out=(char)x;
          *(out+1)='\0';

          in++;
          break;

        case '#':
          if (carea)
            strcpy(out,Area_Name(carea->areano));
          else mknl(out);
          break;

        case 'l':
          if (carea)
            strcpy(out,Last_Leaf(infilearea ? carea->filepath : carea->msgpath));
          else mknl(out);
          break;

        case 'n':
          if (carea)
            strcpy(out,infilearea ? carea->fileinfo : carea->msginfo);
          else mknl(out);
          break;

        case 't':
          if (carea)
            strcpy(out,carea->msgname);
          else mknl(out);
          break;

        case 'p':
          if (carea)
            strcpy(out,infilearea ? carea->filepath : carea->msgpath);
          else mknl(out);
          break;
          
        case 'f':
          if ((sarea=(struct _area *)malloc(sizeof(struct _area))) != NULL)
          {
            /* Copy the filename out of the prompt string */
            
            for (s=temp;*++in > 32 && *in < 127;)
              *s++=*in;
          
            *out='\0';
            *s='\0';
            in--;

            /* Copy the current area into the "real" area def, so that the  *
             * tokens in the .BBS file will work correctly.                 */
            
            *sarea=area;
            area=*carea;
            
            Display_File(0,NULL,temp);
            
            area=*sarea;
            free(sarea);
          }
          break;

        case '*':
          if (usernum)
            sprintf(temp,ps_lastread,carea->msgpath);
          else sprintf(temp,ps_lastread_single,carea->msgpath);

          if ((lrfile=shopen(temp,O_RDONLY | O_BINARY)) != -1)
          {
            lseek(lrfile,(long)usr.lastread_ptr*sizeof(int),SEEK_SET);
            read(lrfile,(char *)&lrptr,sizeof(int));
            close(lrfile);

            if (carea->areano==area.areano) /* Snag current bit from cur.area */
              lrptr=last_msg;

            sprintf(temp,sd_msg,carea->msgpath,lrptr+1);

            if (fexist(temp))
              strcpy(out,"*");
            else strcpy(out," ");
          }
          else strcpy(out," ");
          break;
          
        case 'c':
          if (++cnt < min)
          {
            if (max==-1)
              to_skip=1;
            else to_skip=max;
          }
          else cnt=0;
          
          max=min=0;
          break;

        default:
          logit(s(inv_ccmd),*in);
          break;
      }
      
      if (*in != 'c')
      {
        if (to_skip)
        {
          *out='\0';
          to_skip--;
        }
      }

      if (max != -1)
      {
        if (strlen(out) > max)
          out[max]='\0';
      }

      if (!lalign)
      {
        p=out;

        while (strlen(out) < min)
        {
          memmove(p+1,p,strlen(p)+1);

          *p++=' ';
        }
      }
      else if (min != -1)
      {
        while (strlen(out) < min)
          strcat(out," ");
      }

      out += strlen(out);
    }
    else *out++=*in;
  }

  *out='\0';

  return (strlen(outparm));
}


/* This module is just a shell for the '-r' command-line option, and       *
 * takes care of all the restarting tasks.                                 */

void pascal Sys_Rst(void)
{
  char restart_name[PATHLEN];

  current_line=24;

  switch (System_Restart(restart_name))
  {
    case 0:
      Display_Options(restart_name,NULL);
      break;

    case 1:
      Display_File(!usr.times ? DISPLAY_pcall : 0,NULL,restart_name);

      if (! usr.times)    /* If newcall */
        usr.times++;

      Display_Options(main_menu,NULL);
      break;
  }

  quit(0);
}

int Highbit_Allowed(void)
{
  extern long scan_time;

  /* If user doesn't have IBM chars, then not allowed */
  if (!usr.ibmchars)
    return FALSE;

  /* If s/he does, then only allow if in right message area type, or if in *
   * the multi-line chat.                                                  */

  if ((inmsgarea && (area.attrib[class] & HIGHBIT)) ||
      scan_time==CHAT_SCAN_TIME)
    return TRUE;

  return FALSE;
}


char * pascal Add_Task_Number(char *fname,char *new)
{
  char *p,*s;
  char tn[10];

  if (new != fname)
    memmove(new,fname,strlen(fname)+1);

  if (task_num)
  {
    /*         s       p    */
    /*         v       v    */
    /* D:\Path\Filename.Ext */

    sprintf(tn,"%02x",task_num);

    p=strrchr(new,'.');
    s=strrchr(new,'\\');

    if (s)
      s++;
    else s=new;

    if (!p)
      p=s+strlen(s);

    if (p <= s+6)
      memmove(p+2,p,strlen(p)+1);
    else if (p==s+7)
    {
      memmove(p+1,p,strlen(p)+1);
      p--;
    }
    else p -= 2;

    *p=*tn;
    *(p+1)=*(tn+1);
  }

  return new;
}


int ExtBarricadeOK(struct _area *ar,int msg,int *is_ext)
{
  FILE *barfile;

  int ret;

  char temp[BUFLEN],
       temp2[BUFLEN];

  if (is_ext)
    *is_ext=FALSE;
  
  if (msg && ! *ar->msgbar)
    return TRUE;
  else if (!msg && ! *ar->filebar)
    return TRUE;

  if ((barfile=shfopen(msg ? ar->msgbar : ar->filebar,fopen_read,
                       O_RDONLY))==NULL)
  {
    logit(cf_barricade,msg ? ar->msgbar : ar->filebar);
    return FALSE;
  }

  ret=FALSE;

  while (fgets(temp2,BUFLEN,barfile) != NULL)
  {
    if (*temp2=='!')
    {
      if (is_ext)
        *is_ext=TRUE;
      
      getword(temp2+1,temp,ctl_delim,1);

      if (eqstri(fancy_str(Strip_Underscore(temp)),usr.name))
      {
        getword(temp2+1,temp,ctl_delim,2);

        if (eqstri(temp,noaccess))
          break;

        ret=TRUE;
        break;
      }
      else if (eqstri(temp,"all"))
      {
        getword(temp2+1,temp,ctl_delim,2);

        if (eqstri(temp,noaccess))
          break;

        ret=TRUE;
        break;
      }
    }
  }

  fclose(barfile);
  return ret;
}

void pascal FindLR_Start(void)
{
  usize=(int)(fsize(PRM(user_file))/(long)sizeof(struct _usr));

  num_ptr=usize+1;
  byt=max(1,num_ptr/CHAR_BITS);
  num_ptr=num_ptr-CHAR_BITS;

  if ((lastread_used=(char *)malloc(byt))==NULL)
  {
    logit(nomls);
    quit(ERROR_critical);
  }

  /* Initialize it... */
  memset(lastread_used,'\0',byt);
}


void pascal FindLR_AddOne(int lr_ptr,int unumb)
{
  int o_byt;

  if (lr_ptr >= num_ptr)
  {
    /* Make sure we don't really screw up via realloc() call... */

    if (lr_ptr >= 2048)
      return;

    o_byt=byt;

    usize=lr_ptr+50;
    num_ptr=usize+1;
    byt=max(1,num_ptr/CHAR_BITS);
    num_ptr=num_ptr-CHAR_BITS;

    if ((lastread_used=realloc(lastread_used,byt))==NULL)
    {
      logit(nomls);
      quit(ERROR_critical);
    }

    memset(lastread_used+o_byt,'\0',byt-o_byt);
  }

  /* If user's lastread pointer is cross-linked, warn SysOp */

  if (IsBit(lastread_used,lr_ptr))
    logit(s(log_lread_xlink),unumb);
  else BitOn(lastread_used,lr_ptr);
}


int pascal FindLR_GetFreePtr(void)
{
  int x;

  for (x=0;x < num_ptr;x++)
    if (! IsBit(lastread_used,x))
      break;

  return x;
}

void pascal FindLR_Stop(void)
{
  free(lastread_used);
  lastread_used=NULL;
}


#endif /* !ORACLE */

signed int timeleft(void)
{
  static signed long temptime;

  if ((temptime=(signed long)time(NULL)) > (signed long)timeoff)
    return -1;
  else return ((int)(((signed long)timeoff-temptime)/60L)+1);
}

signed int timeonline(void)
{
  return ((int)((time(NULL)-(signed long)timeon)/60L));
}



void pascal Local_Beep(int n)
{
  int x;

  for (x=0;x < n;x++)
  {
    #ifdef OS_2
      DosBeep(300,50);
    #else
      fputchar('\a');
    #endif
  }
}

int Convert_Star_To_Task(char *filename)
{
  char temp[10],
       *p;

  if ((p=strchr(filename,'*')) != NULL)
  {
    sprintf(temp,"%02X",task_num);

    memmove(p+1,p,strlen(p)+1);
    p[0]=temp[0];
    p[1]=temp[1];

    return TRUE;
  }

  return FALSE;
}


char * pascal fancier_str(char *str)
{
  char *s;
  char lower=0;

  s=str;

  /* If the name is okay, and properly punctuated */
  if (! (isupper(*s) && strpbrk(s,"abcdefghijklmnopqrstuvwxyz")) && s)
  {
    while (*s)
    {
      if (lower)
        *s=tolower(*s);
      else *s=toupper(*s);

      lower=(isalnum(*s++));
    }
  }

  return str;
}


char * pascal Strip_Trailing_Blanks(char *s)
{
  char *p;

  p=s+strlen(s);

  while (*(--p)==' ' && p >= s)
    *p='\0';

  return s;
}

int pascal is_wd(char ch)
{
  if (ch==' ' || ch==',' || ch==';' || ch=='-')
    return TRUE;

  return FALSE;
}


void WhiteN(void)
{
  Puts(WHITE);
  
  if (usr.help != HOTFLASH && ! *linebuf)
    Puts("\n");
}




/* Tells the user to press enter */
void pascal Press_ENTER(void)
{
  char string[BUFLEN];

  OpusGetsL(string,BUFLEN,press_enter);

  display_line=1;
}


/* Sends the cursor to the top line of the screen, for HotFlash input!
   If mode==LINE_top, the cursor is sent to the top line and the current
   attribute is changed to black on white.  Else if mode==LINE_restore,
   then the colour attribute is restored, and the cursor is restored to
   its former position.                                                   */

void pascal TopLine(int mode)
{
  static char save_x,
              save_y,
              local_x,
              local_y,
              sattr;

  if (usr.help==HOTFLASH)
  {
    if (mode==LINE_top)
    {

      /* In case we make another "TopLine(LINE_top)" before the next restore.
         By only saving the current position when topline==FALSE, we ensure
         that doing two LINE_top's in a row doesn't muck up the works.      */

      if (!topline)
      {
        save_x=current_col;
        save_y=current_line;
        sattr=mdm_attr;

        /* Save the LOCAL screen location, since it may be different from
           the callers' (if they use a different screen length or width),
           and it may make some of the prompts look really icky on our
           side if we don't do this...                                  */

        vbuf_flush();

#ifdef OS_2
        if (displaymode==VIDEO_ibm)
          Vidfcur();
#endif

        fossil_getxy(&local_y,&local_x);
      }

      topline=TRUE;

      realgoto=TRUE;
      Printf("%s" BLKONWHIT CLEOL,avt_home);
      realgoto=FALSE;
    }
    else if (mode==LINE_restore)
    {
      if (topline)
      {
        topline=FALSE;  /* Indicate that we're on the top line no longer */
        realgoto=TRUE;  /* Make sure goto's refer to actual screen co-ord's */

        /* Clear the top line */
        Printf("%s" GRAY CLEOL,avt_home);

        Printf(attr_string,sattr);

        /* Return to the right place for the user */
        Mdm_printf(goto_str,save_y,save_x);

        /* Put the Sysop's cursor in the right spot, too */
        Lprintf(goto_str,local_y+1,local_x+1);

        realgoto=FALSE;
      }
    }
  }
}


/* Do a more y/n/= only when required, keeping track of the current line,
   HotFlash state, etc.  Nonstop should be a pointer to a char in the
   calling program, which indicates whether or not we're supposed to be
   running in non-stop mode.  (You shoukd initialize it to FALSE.)         */

int pascal MoreYnBreak(char *nonstop,char *colour)
{
  if (display_line >= usr.len-(usr.help==HOTFLASH ? 1 : 0) &&
      usr.more && !*nonstop)
  {
    if (colour != NULL)
      Puts(colour);

    switch (MoreYnns())
    {
      case YES:
        break;

      case M_NONSTOP:
        *nonstop=TRUE;
        break;

      case NO:
        display_line=1;
        return TRUE;
    }

    display_line=1;
  }

  return FALSE;
}


int pascal Trim_Line(char *s)
{
  char *p;
  int trimmed=FALSE;
  
  p=s+strlen(s)-1;
  
  while (p >= s && (*p=='\r' || *p=='\n'))
  {
    *p--='\0';
    trimmed=TRUE;
  }
  
  return trimmed;
}


int pascal hot_keys(struct _usr *usr)
{
  return (usr->help==HOTFLASH || (usr->bits & BITS_hotkeys));
}


/* Finds the "tag" for a certain area, which is the last directory given
   in the path.  ie. The tag for "D:\Maximus\File\Upload\" is "Upload".    */

void pascal Msg_Area_Tag(void)
{
  strcpy(areatag,Last_Leaf(area.msgpath));
}

/* Get the last word out of a filename or path...  ie. The returned value  *
 * for "D:\Msg\Xyz" would be "Xyz".                                        */

char * pascal Last_Leaf(char *dir)
{
  char temp[PATHLEN],
       temp3[PATHLEN],
       *p;

  static char temp2[14];

  strcpy(temp,dir);
  *temp3='\0';

  p=(char *)strtok(temp,path_delim);

  while (p)
  {
    getword(p,temp3,path_delim,1);
    p=(char *)strtok(NULL,path_delim);
  }

  fancy_str(temp3);
  strncpy(temp2,temp3,12);
  temp2[12]='\0';
  
  return temp2;
}


int pascal Last_Msg(void)
{
  if (last != MENU_msg || entry==ENTRY_true || entry==ENTRY_noheader ||
      entry==ENTRY_nocheck || entry==ENTRY_nohdr || entry==ENTRY_nochecke)
    return Last_Msg_Overlay();
  else return 0;
}


int pascal Last_File(void)
{
  int x;

  if (inmsgarea)
    Fix_Lastread();

  if (last != MENU_file || entry==ENTRY_true || entry==ENTRY_noheader ||
      entry==ENTRY_nocheck || entry==ENTRY_nochecke)
    if ((x=Last_File_Overlay()) != 0)
      return x;

  inmsgarea=FALSE;

  return 0;
}


